//
//  ViewController.swift
//  SwiftPaymentApp
//
//  Created by Karmendra Suthar on 13/05/18.
//  Copyright © 2018 Omniware. All rights reserved.
//

import UIKit
import WebKit

class ViewController: UIViewController, UIWebViewDelegate {

    @IBOutlet weak var webView: UIWebView!
    var salt_str = "3f43kkk0689cb8446cbe6b9d99a418e051c3e320"
    var api_key_str = "f14e50fd-82f0-4ce0-bd4e-de924908d4ff"
    var return_url_str = "https://biz.traknpay.in/tnp/return_page_ios.php"

    override func viewDidLoad() {
        super.viewDidLoad()
        
        let order_id_str = "803"
        let mode_str = "LIVE"
        let amount_str = "5.00"
        let currency_str = "INR"
        let description_str = "IOS Swift Test"
        let name_str = "Name"
        let email_str = "email@example.com"
        let phone_str = "9876543210"
        let address_line_1_str = "address line 1"
        let address_line_2_str = "address line 2"
        let city_str = "Bangalore"
        let country_str = "India"
        let zip_code_str = "560001"
        
        let paymentRequestDictionary = [
            "api_key" : api_key_str,
            "order_id" : order_id_str,
            "mode" : mode_str,
            "amount" : amount_str,
            "currency" : currency_str,
            "description" : description_str,
            "name" : name_str,
            "email" : email_str,
            "phone" : phone_str,
            "address_line_1" : address_line_1_str,
            "address_line_2" : address_line_2_str,
            "city" : city_str,
            "country" : country_str,
            "zip_code" : zip_code_str,
            "return_url" : return_url_str
        ]
        var hashData = salt_str
        var post = ""
        let paymentRequestSortedTuple = paymentRequestDictionary.sorted(by: <)
        for paymentRequestElement in paymentRequestSortedTuple {
            if !(paymentRequestElement.value == ""){
                hashData = hashData + ("|")
                hashData = hashData + (paymentRequestElement.value)
                post = post + ("\(paymentRequestElement.key)=\(paymentRequestElement.value)&")
            }
        }
        
        let hash = sha512Hex(string: hashData)
        post = post + ("hash=\(hash.uppercased())")
        let postData: Data? = post.data(using: .ascii, allowLossyConversion: true)
        
        let url = URL(string: "https://biz.traknpay.in/v2/paymentrequest")
        var request = URLRequest(url: url!)
        request.httpMethod = "POST"
        request.setValue("\(UInt(postData?.count ?? 0))", forHTTPHeaderField: "Content-Length")
        request.httpBody = postData
        
        print("Hash Data \(hashData)")
        print("Post: \(post)")

        webView.delegate = self
        webView.loadRequest(request)
    }
    
    func sha512Hex( string: String) -> String {
        var digest = [UInt8](repeating: 0, count: Int(CC_SHA512_DIGEST_LENGTH))
        if let data = string.data(using: String.Encoding.utf8) {
            let value =  data as NSData
            CC_SHA512(value.bytes, CC_LONG(data.count), &digest)
            
        }
        var digestHex = ""
        for index in 0..<Int(CC_SHA512_DIGEST_LENGTH) {
            digestHex += String(format: "%02x", digest[index])
        }
        
        return digestHex
    }

    func webViewDidStartLoad(_ webView: UIWebView) {
        print("Started Page load")
    }
    
    func webViewDidFinishLoad(_ webView: UIWebView) {
        print("Finished Page load: \(webView.request?.url?.absoluteString ?? "")")
        if (webView.request?.url?.absoluteString == return_url_str) {
            let postData: Data? = webView.request?.httpBody
            var paymentResponse: String? = nil
            if let aData = postData {
                paymentResponse = String(data: aData, encoding: .utf8)
            }
            print("Response: \(paymentResponse ?? "")")
            //Parse the payment response string and update transaction status as required
        }
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    
}


